package com.cyx.config;

import com.alibaba.druid.filter.stat.StatFilter;
import com.cyx.db.Jdbc;
import com.jfinal.config.JFinalConfig;
import com.jfinal.config.*;
import com.jfinal.kit.PropKit;
import com.jfinal.plugin.activerecord.ActiveRecordPlugin;
import com.jfinal.plugin.activerecord.dialect.AnsiSqlDialect;
import com.jfinal.plugin.cron4j.Cron4jPlugin;
import com.jfinal.plugin.druid.DruidPlugin;
import com.jfinal.template.Engine;
/**
 * @Author Created by cyx.zhang Administrator on 2024/3/1 16:11 周五
 * @Description: TOTO
 */
public class AppConfig extends JFinalConfig {


  /**
   * 配置基础常量
   */
  @Override
  public void configConstant(Constants constants) {
    //设置编码格式
    constants.setEncoding("utf-8");
  }

  /**
   * 配置基础插件
   */
  @Override
  public void configPlugin(Plugins plugins) {
    //配置Druid数据库连接池插件
    DruidPlugin druidPlugin = Jdbc.createDruidPlugin();
    //配置Druid数据库连接池大小
    druidPlugin.set(20, 20, 100);
    //添加 StatFilter 才会有统计数据
    druidPlugin.addFilter(new StatFilter());
    plugins.add(druidPlugin);

    //配置ActiveRecord插件
    ActiveRecordPlugin arp = new ActiveRecordPlugin(druidPlugin);
    plugins.add(arp);
    arp.setDialect(new AnsiSqlDialect());

    //配置任务调度插件
    Cron4jPlugin cp = new Cron4jPlugin(PropKit.use("cron4j.properties"),"cron4j");
    plugins.add(cp);
  }

  /**
   * 配置路由
   */
  @Override
  public void configRoute(Routes routes) {}

  /**
   * 配置模板引擎，通常情况只需配置共享的模板函数
   */
  @Override
  public void configEngine(Engine engine) {}
  /**
   * 配置全局拦截器
   */
  @Override
  public void configInterceptor(Interceptors interceptors) {}
  /**
   * 配置处理器
   */
  @Override
  public void configHandler(Handlers handlers) {}
}
