package com.cyx.entry;

import cn.hutool.http.HttpRequest;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson2.JSON;
import com.cyx.base.BaseCow;
import com.cyx.event.Add;
import com.cyx.event.Edit;
import com.cyx.img.Image;
import com.cyx.json.EventJson;
import com.cyx.log.EventLog;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Record;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Author Created by cyx.zhang Administrator on 2024/3/4 8:43 周一
 * @Description: 调用入口
 */
public class Entry {

  /**
   * 定义牧场标识（创耀信）与牧场标识关系（一牧云）
   * @param value
   * @return
   */
  public static Long getKey(String value){
    Map<Long, String> map = new HashMap<>();
    map.put(23L,"1abe187269fd4fae8f6998371cf8076b");//奶一 23
    map.put(2L,"f077ed9f80eb4134a6979dda2ff9a2dd");//奶二 2
    map.put(3L,"91387c89dc6e4fdd9dcf609312fe2f4b");//奶三 3
    map.put(14L,"e592aa9876de423b9cd4ddf756abb7ae");//奶四 14
    map.put(25L,"3e9a1849279c4f1aaa614c218fa9bccf");//奶五 25
    map.put(4L,"2a689a0160a24d15816e48a0d7c2b1b9");//奶六 4
    map.put(9L,"be012fc9d6dd427e886ba5b12661984e");//茂盛 9
    map.put(62L,"95609f9052314b6c8eb09e626bef37cb");//暖泉 62
    map.put(10L,"e85f8c3f3184438babf74187ae5590c2");//渠口 10
    map.put(8L,"928b0ce4db39481e9e9c50722afb496d");//连湖 8
    map.put(12L,"13fadf3ab41e42f59878f53b20136b08");//简泉 12
    map.put(5L,"81289500a97f44d59d2bc1d8462789d4");//灵武 5
    map.put(16L,"d62bc0aff0f14fbaa33333d2aef15eee");//兴垦 16
    map.put(17L,"890da0321ff744a8b07a93160c90e18f");//白土岗一 17
    map.put(101L,"c309e27f59e6469b8c6b76371c74c11f");//白土岗二 101
    map.put(81L,"27a0dc15a5ee431da59f1578f2ab1dc4");//利垦一 81
    map.put(141L,"855673b96f6642b8a829c8a1d32e9f29");//利垦二场 141
    map.put(178L,"b1b9ac287c7943a78c053820ff26fb66");//兴垦二场 178
    Long key = map.entrySet().stream()
        .filter(entry -> entry.getValue().equals(value))
        .map(Map.Entry::getKey)
        .findFirst()
        .orElse(null);
    return key;
  }

  /**
   * 定义牧场名称与牧场标识关系（一牧云）
   * @param value
   * @return
   */
  public static String getKeyName(String value){
    Map<String, String> map = new HashMap<>();
    map.put("奶一牧场","1abe187269fd4fae8f6998371cf8076b");//奶一 23
    map.put("奶二牧场","f077ed9f80eb4134a6979dda2ff9a2dd");//奶二 2
    map.put("奶三牧场","91387c89dc6e4fdd9dcf609312fe2f4b");//奶三 3
    map.put("奶四牧场","e592aa9876de423b9cd4ddf756abb7ae");//奶四 14
    map.put("奶五牧场","3e9a1849279c4f1aaa614c218fa9bccf");//奶五 25
    map.put("平六牧场","2a689a0160a24d15816e48a0d7c2b1b9");//奶六 4
    map.put("茂盛牧场","be012fc9d6dd427e886ba5b12661984e");//茂盛 9
    map.put("暖泉牧场","95609f9052314b6c8eb09e626bef37cb");//暖泉 62
    map.put("渠口牧场","e85f8c3f3184438babf74187ae5590c2");//渠口 10
    map.put("连湖牧场","928b0ce4db39481e9e9c50722afb496d");//连湖 8
    map.put("简泉牧场","13fadf3ab41e42f59878f53b20136b08");//简泉 12
    map.put("灵武牧场","81289500a97f44d59d2bc1d8462789d4");//灵武 5
    map.put("兴垦牧业","d62bc0aff0f14fbaa33333d2aef15eee");//兴垦 16
    map.put("白土岗一场","890da0321ff744a8b07a93160c90e18f");//白土岗一 17
    map.put("白土岗二场","c309e27f59e6469b8c6b76371c74c11f");//白土岗二 101
    map.put("利垦一场","27a0dc15a5ee431da59f1578f2ab1dc4");//利垦一 81
    map.put("利垦二场","855673b96f6642b8a829c8a1d32e9f29");//利垦二场 141
    map.put("兴垦二场","b1b9ac287c7943a78c053820ff26fb66");//兴垦二场 178
    String key = map.entrySet().stream()
        .filter(entry -> entry.getValue().equals(value))
        .map(Map.Entry::getKey)
        .findFirst()
        .orElse(null);
    return key;
  }

  /**
   * 定义牧场名称与牧场标识关系（创耀信）
   * @return
   */
  public static Map<String, Integer> sourceCow(){
    Map<String, Integer> map = new HashMap<>();
    map.put("奶一牧场",23);//奶一
    map.put("奶二牧场",2);//奶二
    map.put("奶三牧场",3);//奶三
    map.put("奶四牧场",14);//奶四
    map.put("奶五牧场",25);//奶五
    map.put("平六牧场",4);//奶六
    map.put("茂盛牧场",9);//茂盛
    map.put("暖泉牧场",62);//暖泉
    map.put("渠口牧场",10);//渠口
    map.put("连湖牧场",8);//连湖
    map.put("简泉牧场",12);//简泉
    map.put("灵武牧场",5);//灵武
    map.put("兴垦牧业",16);//兴垦
    map.put("白土岗一场",17);//白土岗一
    map.put("白土岗二场",101);//白土岗二
    map.put("利垦一场",81);//利垦
    map.put("利垦二场",141);//利垦
    map.put("兴垦二场",178);//兴垦
    return map;
  }

  /**
   * 同步事件数据
   * @param args
   */
  public static void synsData(String[] args){
    String[] farmIds = args[1].split(",");
    for(String farmId : farmIds){
      EventLog.info("------["+args[4]+"]-["+args[5]+"]------");
      EventLog.info("......牛场标识：创耀信["+getKey(farmId)+"],一牧云["+farmId+"]...开始......");
      String str = HttpRequest.get("http://dairyapp.yimucloud.com:8085/dweb/login/apiLogin?platForm=DWeb&orgCode=DG64001&sign=pVibK5VxEpU=").execute().body();
      JSONObject obj = new JSONObject(str);
      JSONObject result = obj.getJSONObject("result");
      String token = result.getStr("token");//获取token
      String[] eventIds = args[2].split(",");
      for(String eventId : eventIds){
        EventLog.info("......事件标识：["+eventId+"]...开始......");
        int total = 0;
        int count = 1;
        for(int i=1;i<=count;i++){
          EventLog.info("第["+i+"]页开始......");
          String url = "http://dairyapp.yimucloud.com:8085/dweb/party/event/getEventSingleInfoList?";
          url = url + "farmId="+farmId;
          url = url + "&pageNo="+i;
          url = url + "&pageSize="+args[3];
          url = url + "&eventId="+eventId;
          url = url + "&beginDate="+args[4];
          url = url + "&endDate="+args[5];
          String resultStr = HttpRequest.get(url).header("X-Access-Token",token).execute().body();
          if(i==1){
            count = com.alibaba.fastjson2.JSON.parseObject(resultStr).getJSONObject("result").getInteger("pages");
          }
          if("200".equals(JSONUtil.parseObj(resultStr).getStr("msgId"))){
            JSONArray arrayList = JSONUtil.parseObj(resultStr).getJSONObject("result").getJSONArray("records");
            if(arrayList.size()>0){
              total = total+arrayList.size();
            }
            for (int j = 0; j < arrayList.size(); j++) {
              JSONObject param = arrayList.getJSONObject(j);
              EventLog.info("第("+(j+1)+")头...["+param.get("COW_NAME")+"]...["+param.get("EVENT_DATE")+"]......");
              //转群转圈
              if("101".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamTurn(param);
                Add.dealTurn(reJSON,getKey(farmId),args[6]);
              }
              //断奶
              if("102".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamAblactation(param);
                Add.dealAblactation(reJSON,getKey(farmId));
              }
              //死亡
              if("103".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamDeath(param);
                Add.dealExit(reJSON,getKey(farmId));
              }
              //淘汰
              if("104".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamWeedOut(param);
                Add.dealExit(reJSON,getKey(farmId));
              }
              //体况
              if("105".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamBodyScore(param);
                Add.dealBodyScore(reJSON,getKey(farmId));
              }
              //体测
              if("106".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamBodyMeasure(param);
                Add.dealBodyMeasure(reJSON,getKey(farmId));
              }
              //乳头评分
              if("107".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamNipple(param);
                Add.dealNipple(reJSON,getKey(farmId));
              }
              //产犊
              if("201".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamCalving(param);
                Add.dealCalving(reJSON,getKey(farmId));
              }
              //初检
              if("202".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamPregnancy(param);
                Add.dealPregnancy(reJSON,getKey(farmId));
              }
              //复检
              if("203".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamReInspection(param);
                Add.dealReInspection(reJSON,getKey(farmId));
              }
              //配种
              if("205".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamBreed(param);
                Add.dealBreed(reJSON,getKey(farmId));
              }
              //围产
              if("206".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamPerinatal(param);
                Add.dealPerinatal(reJSON,getKey(farmId));
              }
              //流产
              if("207".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamAbort(param);
                Add.dealAbort(reJSON,getKey(farmId));
              }
              //禁配
              if("208".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamProhibition(param);
                Add.dealProhibition(reJSON,getKey(farmId));
              }
              //干奶
              if("209".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamDryMilk(param);
                Add.dealDryMilk(reJSON,getKey(farmId));
              }
              //犊牛
              if("211".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamCalf(param);
                Add.dealCalf(reJSON,getKey(farmId));
              }
              //细菌培养
              if("411".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamGerm(param);
                Add.dealGerm(reJSON,getKey(farmId));
              }
              //盲乳头
              if("412".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamBlindNipple(param);
                Add.dealBlindNipple(reJSON,getKey(farmId));
              }
              //修蹄
              if("414".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamRepairHooves(param);
                Add.dealRepairHooves(reJSON,getKey(farmId));
              }
              //免疫
              if("417".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamImmunity(param);
                Add.dealImmunity(reJSON,getKey(farmId));
              }
              //隐乳检测
              if("422".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamCryptic(param);
                Add.dealCryptic(reJSON,getKey(farmId));
              }
              //产后护理
              if("423".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamNurse(param);
                Add.dealNurse(reJSON,getKey(farmId));
              }
              //抗生素检测
              if("424".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamAntibiotic(param);
                Add.dealAntibiotic(reJSON,getKey(farmId));
              }
              //亚临床酮病
              if("425".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamKetosis(param);
                Add.dealKetosis(reJSON,getKey(farmId));
              }
              //亚临床乳房炎
              if("426".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamMastitis(param);
                Add.dealMastitis(reJSON,getKey(farmId));
              }
              //血酮检测
              if("504".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamBloodKetone(param);
                Add.dealBloodKetone(reJSON,getKey(farmId));
              }
              //同期
              if("503".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamSync(param);
                Add.dealSync(reJSON,getKey(farmId));
              }
              //投磁铁
              if("505".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamMagnet(param);
                Add.dealMagnet(reJSON,getKey(farmId));
              }
              //产后保健
              if("507".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamProtection(param);
                Add.dealProtection(reJSON,getKey(farmId));
              }
              //去角
              if("510".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamChamfer(param);
                Add.dealChamfer(reJSON,getKey(farmId));
              }
              //免疫球蛋白
              if("512".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamImmunoglobulin(param);
                Add.dealImmunoglobulin(reJSON,getKey(farmId));
              }
              //初乳灌服
              if("513".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamGavage(param);
                Add.dealGavage(reJSON,getKey(farmId));
              }
              //尿液PH
              if("514".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamUrinePH(param);
                Add.dealUrinePH(reJSON,getKey(farmId));
              }
              //初乳收集
              if("515".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamCollect(param);
                Add.dealCollect(reJSON,getKey(farmId));
              }
              //子宫评分
              if("517".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamUterus(param);
                Add.dealUterus(reJSON,getKey(farmId));
              }
              //步态
              if("519".equals(eventId)){
                com.alibaba.fastjson2.JSONObject reJSON = EventJson.setParamGaitScore(param);
                Add.dealGaitScore(reJSON,getKey(farmId));
              }
            }
          }
          EventLog.info("第["+i+"]页结束......");
        }
        EventLog.info("......事件["+eventId+"]总量：["+total+"]头......");
        EventLog.info("......事件标识：["+eventId+"]...结束......");
        EventLog.info("......2秒后继续......");
        try {
          Thread.sleep(2000L);
        } catch (InterruptedException e) {
          e.printStackTrace();
        }
      }
      EventLog.info("......牛场标识：创耀信["+getKey(farmId)+"],一牧云["+farmId+"]...结束......");
      EventLog.info("------["+args[4]+"]-["+args[5]+"]------");
    }
  }

  /**
   * 修改数据
   * @param args
   */
  public static void editData(String[] args){
    String[] farmIds = args[1].split(",");
    for(String farmId : farmIds){
      EventLog.info("------["+args[2]+"]-["+args[3]+"]------");
      EventLog.info("......牛场["+farmId+"]判决开始......");
      Edit.dealEdit(farmId,args[2],args[3]);
      EventLog.info("......牛场["+farmId+"]判决结束......");
      EventLog.info("------["+args[2]+"]-["+args[3]+"]------");
    }
  }

  /**
   * 基础信息数据
   * @param args
   */
  public static void InfoData(String[] args){
    String str = HttpRequest.get("http://dairyapp.yimucloud.com:8085/dweb/login/apiLogin?platForm=DWeb&orgCode=DG64001&sign=pVibK5VxEpU=").execute().body();
    JSONObject obj = new JSONObject(str);
    JSONObject result = obj.getJSONObject("result");
    JSONArray farmArray = result.getJSONObject("loginUserVO").getJSONArray("farmList");
    String token = result.getStr("token");//获取token
    for(int i=0;i<farmArray.size();i++){
      int count = 1;
      for(int j=1;j<=count;j++){
        JSONObject farm = farmArray.getJSONObject(i);
        Integer sourceCow = sourceCow().get(farm.getStr("shortName"));//牛场名称
        if(!farm.getStr("shortName").equals(args[1])){
          continue;
        }
        EventLog.info("..."+farm.getStr("shortName")+"("+sourceCow+")...第"+j+"页...开始...");
        String url = "http://dairyapp.yimucloud.com:8085/dweb/party/cowInfo/getCowInfo";
        com.alibaba.fastjson2.JSONObject boby = new com.alibaba.fastjson2.JSONObject();
        boby.put("farmId",farm.getStr("farmId"));
        boby.put("pageNo",j);
        boby.put("pageSize",args[2]);
        String resultStr = HttpRequest.post(url)
            //头信息，多个头信息多次调用此方法即可
            .header("X-Access-Token", token)
            .header("Content-Type","application/json;charset=UTF-8")
            .body(String.valueOf(boby))
            //超时，毫秒
            .timeout(20000)
            .execute().body();
        com.alibaba.fastjson2.JSONArray arrayList = JSON.parseObject(resultStr).getJSONObject("result").getJSONArray("records");
        if(j==1){
          count = JSON.parseObject(resultStr).getJSONObject("result").getInteger("pages");
        }
        if(null != sourceCow){
          //处理父亲、母亲
          if("0".equals(args[3])){
            BaseCow.syncBaseCowFMData(arrayList, sourceCow.longValue());
          }
          //处理外祖父、外祖母
          if("1".equals(args[3])){
            BaseCow.syncBaseCowGrandFMData(arrayList, sourceCow.longValue());
          }
          //处理圈舍
          if("2".equals(args[3])){
            BaseCow.syncBaseCowShedData(arrayList, sourceCow.longValue());
          }
          //处理牛只基础信息
          if("3".equals(args[3])){
            BaseCow.syncBaseCowData(arrayList, sourceCow.longValue());
          }
          //处理牛只基础信息（不包含照片）和繁育信息及胎次信息
          if("4".equals(args[3])){
            BaseCow.syncBaseCowAndBreedAndParityData(arrayList, sourceCow.longValue());
          }
          //处理繁育信息(不包含胎次、产犊日期)
          if("5".equals(args[3])){
            BaseCow.syncBreedData(arrayList, sourceCow.longValue());
          }
          //处理图片
          if("6".equals(args[3])){
            if(null != arrayList && arrayList.size()>0){
              Image.syncBaseCowImage(arrayList, sourceCow.longValue(),args[4]);
            }
          }
        }
      }
    }
  }

  /**
   * 获取图片数据
   * @param args
   */
  public static void ImageData(String[] args){
    String farmId = args[1];
    Long sourceCow = getKey(farmId);
    List<Record> list = Db.find("select cow_no as cowNo from t_base_cow where source_cow = '"+sourceCow+"' and front_image is not null and left_side_image is not null and right_side_image is not null");
    if(list.size()>0){
      for (Record record : list){
        String resultStr = HttpRequest.get("https://dairy.yimucloud.com/dweb/searches/searchInfo/getCowInfoList?farmId="+farmId+"&cowName="+record.getStr("cowNo")+"").execute().body();
        com.alibaba.fastjson2.JSONArray arrayList = JSON.parseObject(resultStr).getJSONArray("result");
        EventLog.info("...resultStr..."+resultStr);
        if(null != arrayList && arrayList.size()>0){
          Image.syncBaseCowImage(arrayList, sourceCow.longValue(),args[2]);
        }
        try {
          Thread.sleep(5000L);
        } catch (InterruptedException e) {
          e.printStackTrace();
        }
      }
    }
  }

}
